import pyglet

from config import *

class Audio():

    def __init__(self):
        self.music = pyglet.media.Player()
        self.musicVolume = float(config.get("Audio","musicVolume")) / 100.0
        self.sfxVolume = float(config.get("Audio","sfxVolume")) / 100.0
        self.sounds = {}
    
    def PlayMusic(self, trackName, introName=None):
        self.music.next()

	if introName != None:
		self.music.queue(pyglet.resource.media(introName, streaming = True))
		# nice hack, thank you very much
		i=0;
		while i < 100:
			self.music.queue(pyglet.resource.media(trackName, streaming = True))
			i += 1;

        	self.music.play()
		self.music.eos_action = "next"
	else:

		self.music.queue(pyglet.resource.media(trackName, streaming = True))
		self.music.play()
		self.music.eos_action = 'loop'

	self.SetMusicVolume(int(config.get("Audio","musicVolume")))

    def StopMusic(self):
        self.music.pause()

    def SetMusicVolume(self,volume):
	print "Setting music volume to ", volume
	print "Converted to ", float(volume / 100.0)
        self.music.volume = float(volume / 100.0)
        self.musicVolume = float(volume / 100.0)
        config.set("Audio","musicVolume",str(volume))
        
    def SetSfxVolume(self, volume ):
        self.sfxVolume = float(volume / 100.0)
        config.set("Audio","sfxVolume",str(volume))

    def LoadSfx(self, name):
        if name not in self.sounds:
            print "Loaded new sound ", name
            self.sounds[name] = pyglet.resource.media(name, streaming = False)
        return self.sounds[name]
            
    def CacheSfx(self, list):
        for sfx in list:
            LoadSfx(sfx)

    def PlaySfx(self, name):
        self.LoadSfx(name)
	print "Playing ", name
        self.sounds[name].play().volume = self.sfxVolume
        
    def PlayQuit(self):
        self.music.next()

    def Init(self):
	self.StopMusic()
	del self.music
        self.music = pyglet.media.Player()
        self.musicVolume = float(config.get("Audio","musicVolume")) / 100.0
        self.sfxVolume = float(config.get("Audio","sfxVolume")) / 100.0
        self.sounds = {}
