# 
# Lib includes
#
from cocos.director import director
from cocos import draw
from cocos.layer import *
from main import box2d
import logging

# 
# Game includes
#
from config import *
from globals import *

log = logging.getLogger('Level')

    
groundFilter = box2d.b2FilterData()
groundFilter.categoryBits = 0x0008
groundFilter.maskBits = 0x0006
groundFilter.groupIndex = 0

        
class DebugDrawLevel(draw.Canvas):
    def render(self):
        x,y = director.get_window_size()

        staticLevel = config.items("StaticBackground")
        #print staticLevel

        line_width = 5
        self.set_color( (255,255,0,50) )
        self.set_stroke_width( line_width )
        
        self.set_join( draw.ROUND_JOIN )
        
        for obj in staticLevel:
            #print "obj: ", obj[0],"=", obj[1]
            self.move_to( (0,-10) )
            points = eval(obj[1])
            np = []
            scale = 4.5
            for p in points:
                np.append((p[0]*scale,p[1]*scale-70))#+5 all to try to get it inline with the physics
            for point in np:
                #print "point:",point
                self.line_to( point )
        
class LevelLayer(Layer):
    def __init__(self, world, yoffset):
        super( LevelLayer, self ).__init__()
        self.scale = 4.5
        
        #self.add( DebugDrawLevel() )        
        #self.schedule( lambda x: 0 )
        
        self._loadPhysics(world, yoffset)
        log.debug("LevelLayer::__init__ Complete")
        
    def on_key_press (self, key, modifiers):
        print "LevelLayer Key Pressed:", key, modifiers
        
    def _loadPhysics(self, world, yoffset):
        log.debug("LevelLayer::_loadPhysics")
        staticLevel = config.items("StaticBackground")
        for obj in staticLevel:
            print "obj: ", obj[0],"=", obj[1]
            points = eval(obj[1])
            points.append(points[0])
            np = []
            scale = 4.0#.5#45.0#self.scale
            for p in points:
                np.append((p[0],yoffset-p[1]-6))
            # np = world.translate_coords(np)  
                #np.append((p[0]*scale,p[1]*(-scale)+(768.0/2.0)+50.0))# ewww
            #np.reverse()
            log.debug("LevelLayer::np: "+str(np))

            poly, points = world.add.complexPoly(np, dynamic=False)
            #print poly
            #shape = poly.GetShapeList()
            #shape.SetFilterData(groundFilter)

        log.debug("LevelLayer::_loadPhysics Complete")
