import pyglet
from main import box2d
from globals import *
from item import SquareItem

gRope = []
       
       

playerFilter = box2d.b2FilterData()
playerFilter.categoryBits = k_PlayerCategory
playerFilter.maskBits = k_PlayerMask
playerFilter.groupIndex = k_PlayerGroup
ropeFilter = box2d.b2FilterData()
ropeFilter.categoryBits = k_RopeCategory
ropeFilter.maskBits = k_RopeMask
ropeFilter.groupIndex = k_RopeGroup

class Rope():
    def __init__(self, world, layer, plr1, plr2 = None, width = 8.0, links = 20):
        self.startPos = plr2.body.GetPosition()
        self.endPos = plr1.body.GetPosition()
        self.startBody = plr2.body
        self.endBody = plr1.body
        
        if (plr2.position[0] > plr1.position[0]):
            self.startPos = plr1.body.GetPosition()
            self.endPos = plr2.body.GetPosition()
            self.startBody = plr1.body
            self.endBody = plr2.body
        else:
            print "plr 2 on left of plr1"
            
        self.startPos = (self.startPos.x*gPPM, self.startPos.y*gPPM)
        self.endPos = (self.endPos.x*gPPM, self.endPos.y*gPPM)
        
        shape = self.startBody.GetShapeList()
        shape.SetFilterData(playerFilter)
        shape = self.endBody.GetShapeList()
        shape.SetFilterData(playerFilter)
            
        print "Links Start at:::: ",self.startPos[0],"-->",self.endPos[0]
        #self.startPos = (self.startPos[1], self.startPos[1])
        #self.endPos = (self.endPos[1], self.endPos[1])
        self.ropeImg = pyglet.resource.image('rope.png')
        #self.ropeImg.width = self.ropeImg.width/2.0
            
        self.RevJoing(world, layer, plr1, plr2, width, links)
        #self.InitJoints(world, layer, plr1, plr2, width, links)
       
    def InitJoints(self, world, layer, plr1, plr2, width, numLinks):

        linkWidth = int((self.endPos[0]-self.startPos[0])/numLinks)+1
        linkHeight = int(width )
        print "Link:",linkWidth, linkHeight
        
        #plr1pos = 
        
        achorXoffset = linkWidth*0.49
        prevBody = self.startBody
        
        anchorPrev = self.startPos
        for i in range(int(numLinks)):
            newCenterX = self.startPos[0] + i*linkWidth
            objPos = ( newCenterX, self.startPos[1])
            
            print "Add obj:", objPos
            #body = world.add.rect(objPos, width=linkWidth, height=linkHeight, density = 0.01)
            rope = SquareItem("rope", world, self.ropeImg, objPos, width = linkWidth, height = linkHeight)#, usefg = [ 0x0004,0x0002,-8])#,scale = 0.5)
            gRope.append(rope)
            layer.add(rope)
            
            shape = rope.body.GetShapeList()
            shape.SetFilterData(ropeFilter)

            
            anchorNew = (newCenterX - achorXoffset,  self.startPos[1])
            
            print "Add joint:", anchorPrev, anchorNew
            world.add.joint(prevBody, rope.body, anchorPrev, anchorNew, False)
            
            anchorPrev = (newCenterX+achorXoffset,  self.startPos[1])
            
            prevBody = rope.body
            
        world.add.joint(prevBody, self.endBody, anchorPrev, self.endPos, False)

    def RevJoing(self, world, layer, plr1, plr2, width, numLinks):

        linkWidth = int((self.endPos[0]-self.startPos[0])/(numLinks))+1
        linkHeight = int(width )
        achorXoffset = linkWidth*0.95
        
        print "Link:",linkWidth, linkHeight, numLinks, achorXoffset
        #plr1pos = 
        
        
       
        prevBody = self.startBody
        anchorNew = (self.startPos[0],  self.startPos[1])
        for i in range(int(numLinks)):
            newCenterX = self.startPos[0] + (i+1)*linkWidth
            objPos = ( newCenterX, self.startPos[1])
            
            #body = world.add.rect(objPos, width=linkWidth, height=linkHeight, density = 0.01)#, fg = [ 0x0004,0x0002,-8])
            
            
            rope = SquareItem("rope", world, self.ropeImg, objPos, width = linkWidth, height = linkHeight)#,scale = 0.5)
            gRope.append(rope)
            layer.add(rope)
            
            body = rope.body
            
            shape = body.GetShapeList()
            shape.SetFilterData(ropeFilter)

            print "Adding link:", i, objPos[0] , anchorNew[0]
            pos = prevBody.GetWorldCenter()
            pos = [pos.x*gPPM,pos.y*gPPM]
            
            world.add.joint(prevBody, body, pos)#anchorNew)#jointDef.Initialize(myBody1, myBody2, myBody1->GetWorldCenter());
            #world.add.joint(prevBody, rope.body, pos)#anchorNew)#jointDef.Initialize(myBody1, myBody2, myBody1->GetWorldCenter());
            anchorNew = (newCenterX- achorXoffset,  self.startPos[1])
            prevBody = body#rope.body
            
        anchorNew = (self.endPos[0],  self.endPos[1])#
        pos = prevBody.GetWorldCenter()
        pos = [pos.x*gPPM,pos.y*gPPM]
        world.add.joint(prevBody, self.endBody, self.endPos)#anchorNew)

 